#include <extUtil.h>


void EulerTrans( double *x , double *y , double *z , double Phi1, double Theta, double Phi2)
{
/*Diese Prozedur transformiert einen 3D-Vektor (x,y,z)*/
/*mit den drei Eulerwinkeln in einen neuen Vektor (x,y,z)*/

	 double xi, yi, zi;
	 double m1xy, m2yz, m3xy;
	 double Alf, Bet, Gam;

	 xi = *x;
	 yi = *y;
	 zi = *z;

	 /*Phi2-Transformation*/
	 /*Lnge des Vektors in xy-Richtung*/
	 m1xy = sqrt(xi * xi + yi * yi);
	 /*Berechnung des Winkels Alf des 2D-Vektors mit den*/
	 /*Koordinaten x, y zur x-Achse des Koordinatensystems*/
	 if ((xi > 0) && (yi >= 0))
		Alf = atan(yi / xi);
	 else
	 {
		if ((xi > 0) && (yi < 0))
			Alf = (M_PI/2)*3 + atan( xi / -yi );
		else
		{
			if ((xi < 0) && (yi > 0))
				Alf = M_PI / 2 + atan( -xi/ yi );
			else
			{
				if (( xi < 0) && ( yi <= 0))
					Alf = M_PI + atan( -yi / -xi );
				else
				{
					if (( xi == 0) && ( yi > 0))
						Alf = M_PI / 2;
					else
					{
						if (( xi == 0) && ( yi <= 0))
							Alf = (M_PI/2)*3;
					}
				}
			}
		}
	 }

	 xi = cos(Alf + Phi2) * m1xy;
	 yi = sin(Alf + Phi2) * m1xy;


	 /*Theta-Transformation*/
	 /*Lnge des Vektors in yz-Richtung*/
	 m2yz = sqrt(yi * yi + zi * zi);
	 /*Berechnung des Winkels des 2D-Vektors mit den*/
	 /*Koordinaten Miller.y,Miller.z zur y-Achse des Koordinatensystems*/
	 if (( yi > 0) && ( zi >= 0))
		  Bet = atan( zi / yi);
	 else
	 {
		if (( yi > 0) && ( zi < 0))
		  Bet = (M_PI/2)*3 + atan( yi / -zi);
		else
		{
			if (( yi < 0) && ( zi > 0))
			Bet = M_PI / 2 + atan( -yi / zi);
			else
			{
				if (( yi < 0) && ( zi <= 0))
					Bet = M_PI + atan( -zi / -yi);
				else
				{
					if (( yi == 0) && ( zi > 0))
						Bet = M_PI / 2;
					else
					{
						if (( yi == 0) && ( zi <= 0))
							Bet = (M_PI/2)*3;
					}
				}
			}
		}
	 }
	 yi = cos(Bet + Theta) * m2yz;
	 zi = sin(Bet + Theta) * m2yz;

	/*Phi1-Transformation*/
	/*Lnge des Miller-Vektors in xy-Richtung*/
	 m3xy = sqrt( xi *  xi +  yi *  yi);

	 /*Berechnung des Winkels des 2D-Vektors mit den*/
	 /*Koordinaten  xi, yi zur x-Achse des Koordinatensystems*/
	if (( xi > 0) && ( yi >= 0))
		Gam = atan( yi /  xi);
	else
	{
		if (( xi > 0) && ( yi < 0))
			Gam = (M_PI/2)*3 + atan( xi / -yi);
		else
		{
			if (( xi < 0) && ( yi > 0))
				Gam = M_PI / 2 + atan( -xi / yi);
			else
			{
				if (( xi < 0) && ( yi <= 0))
					Gam = M_PI + atan( -yi / -xi);
				else
				{
					if (( xi == 0) && ( yi > 0))
						Gam = M_PI / 2;
					else
					{
						if (( xi == 0) && ( yi <= 0))
							Gam = (M_PI/2)*3;
					}
				}
			}
		}
	}

	*x = cos(Gam + Phi1) * m3xy;
	*y = sin(Gam + Phi1) * m3xy;
	*z = zi;


} /*Ende Eulertrans*/







