
      int p3_finder(int anzahl_nodes, double *nx, double *nz, int *p)
/* ***********************************************************************   */
/* * Sucht Stuetzpunkte, die ein Dreieck bilden, das den node  umschliest.   */
/* *                                                                         */
/* * Ein:                                                                    */
/* *  n[0] : aktueller node                                                  */
/* *  n[1], n[2] : die 2 naechstliegenden stuetzstellen                      */
/* *  n[3-..] :  stuetzstellenauswahl aus der der bestpassende gefunden      */
/* *  werden soll (sortiert nach abstand!)                                   */
/* * AUS:                                                                    */
/* *  nbest : nodeindex im feld n(index) der am besten passt                 */
/* ***********************************************************************   */
{
int	    n3, n2, inull, iplus, iminus, flag;
double	v1[4],vnode[4],vprod1,vprod2,vprod3;

flag=0;

      for ( n3=3; n3 < anzahl_nodes; n3++)
      {
        for ( n2=2; n2 < n3; n2++)
        {
          if (n3 != n2)
          {

            v1[1]=nx[n2]-nx[1];      /* 1. vektor der flaeche  */
            v1[3]=nz[n2]-nz[1];      /* in der xz-ebene */
            vnode[1]=nx[0]-nx[1];   /*  !vektor zum aktuellen */
            vnode[3]=nz[0]-nz[1];   /*  !node */
            vprod1=v1[3]*vnode[1] - vnode[3]*v1[1];
            if (vprod1 < 0.) vprod1=-1.;
            if (vprod1 > 0.) vprod1=1.;

            v1[1]=nx[n3]-nx[n2];
            v1[3]=nz[n3]-nz[n2];
            vnode[1]=nx[0]-nx[n2];
            vnode[3]=nz[0]-nz[n2];
            vprod2=v1[3]*vnode[1] - vnode[3]*v1[1];
            if (vprod2 < 0.) vprod2=-1.;
            if (vprod2 > 0.) vprod2=1.;

            v1[1]=nx[1]-nx[n3];
            v1[3]=nz[1]-nz[n3];
            vnode[1]=nx[0]-nx[n3];
            vnode[3]=nz[0]-nz[n3];
            vprod3=v1[3]*vnode[1] - vnode[3]*v1[1];
            if (vprod3 < 0.) vprod3=-1.;
            if (vprod3 > 0.) vprod3=1.;

/*           * kontrolle ob und wiefiel vprod=0 sind. Dann liegt naemlich *   */
/*           * der zu kontrollierende node auf der umrandung der kontroll-*   */
/*           * flaeche.                                                   *   */
/*           * Dann werden vprod mit den gleichen vorzeichen zusammen-    *   */
/*           * gezaelt, dabei gelten die nuller als joker                 *   */

            inull=0;
            if (vprod1 == 0.) inull=inull+1;
            if (vprod2 == 0.) inull=inull+1;
            if (vprod3 == 0.) inull=inull+1;

            if (inull == 3) inull=0;

            iplus=inull;
            if (vprod1 == 1.) iplus=iplus+1;
            if (vprod2 == 1.) iplus=iplus+1;
            if (vprod3 == 1.) iplus=iplus+1;

            iminus=inull;
            if (vprod1 == -1.) iminus=iminus+1;
            if (vprod2 == -1.) iminus=iminus+1;
            if (vprod3 == -1.) iminus=iminus+1;

/*            printf ("\n %d %lf %lf %lf",n,vprod1,vprod2,vprod3);   */

/*           * wenn alle vectorprodukte das gleiche vorzeichen haben    *   */
/*           * dann ist der node innerhalb der projektion einer anderen *   */
/*           * flaeche                                                  *   */

           if ((iplus == 3) || (iminus == 3))
           {
           /*       gefunden und return!   */
              p[(int)0]=(int)1; p[(int)1]=n2; p[(int)2]=n3;
              return(1);
           }
           if ((iplus > 1) || (iminus > 1))
           {
			  if (flag == 0)
              {
                /* Now check that the three points we have are not all in a straight line                          */
                if (((nx[1] == nx[n2]) && (nx[n2] == nx[n3])) ||
                 (nz[n3] == ((nz[n2]-nz[1])/(nx[n2]-nx[1])*nx[n3] + nz[1])))
                /*       gefunden und merken!   */
				{
/*                  printf ("straight line\n");   */
                }
                else
                {
                  p[(int)0]=(int)1; p[(int)1]=n2; p[(int)2]=n3;
                  flag = 1;
                }
              }
           }
          }
        }
      }
	 if (flag ==0) return(3);
      return(2);
}

