/* ---------------------------------------------------------------- */
/* read2fbd liest das fbd-file in eine struktur  24.03.2000 Wittig  */
/* ---------------------------------------------------------------- */

#include <extUtil.h>

#define TEST     0

#define INI_FIELD_SIZE 1000
#define MAXVALUE 2147483647


int read2fbd( unsigned char *datin, SumGeo *anz, Points **pntptr, Lines **lineptr, Lcmb **lcmbptr, Gsur **surptr, Gbod **bodptr, Nurbs **nursptr, Sets *set )
{
  FILE *handle1;
  register int i, j;
  unsigned char string[MAX_LINE_LENGTH], apuf[MAX_LINE_LENGTH];
  int  length, flag;
  int  ipuf;

  static Points *pnt;
  static Lines *line;
  static Lcmb *lcmb;
  static Gsur *surf;
  static Gbod *body;
  static Nurbs *nurs;

  /* erstmal speicher allocieren, nicht benoetigter wird spaeter freigegeben  */
  if ( (pnt = (Points *)malloc( INI_FIELD_SIZE * sizeof(Points))) == NULL )
    printf("\n\n ERROR: malloc failed \n\n") ;
  if ( (line = (Lines *)malloc( INI_FIELD_SIZE * sizeof(Lines))) == NULL )
    printf("\n\n ERROR: malloc failed \n\n") ;
  if ( (lcmb = (Lcmb *)malloc( INI_FIELD_SIZE * sizeof(Lcmb))) == NULL )
    printf("\n\n ERROR: malloc failed \n\n") ;
  if ( (surf = (Gsur *)malloc( INI_FIELD_SIZE * sizeof(Gsur))) == NULL )
    printf("\n\n ERROR: malloc failed \n\n") ;
  if ( (body = (Gbod *)malloc( INI_FIELD_SIZE * sizeof(Gbod))) == NULL )
    printf("\n\n ERROR: malloc failed \n\n") ;
  if ( (nurs = (Nurbs *)malloc( INI_FIELD_SIZE * sizeof(Nurbs))) == NULL )
    printf("\n\n ERROR: malloc failed \n\n") ;

  anz->alias=0;
  anz->p=0;
  anz->l=0;
  anz->c=0;
  anz->s=0;
  anz->b=0;
  anz->nurl=0;
  anz->nurs=0;

  /* Open the files and check to see that it was opened correctly */
  handle1 = fopen (datin, "r");
  if ((int)handle1==-1) { printf ("\nThe input file \"%s\" could not be opened.\n\n", datin); return(-1); }
  else  printf (" %s opened\n",datin);


  length = 1;

  printf (" reading fbd commands  \n");
  while (length > -1)
  {
    length = frecord( handle1, string);
    if( string[length]== (unsigned char)EOF) { printf("\nEOF %d\n",string[length]); break; }
    if ((compare(&string[1], "PNT", 3) == 3)||(compare(&string[1], "pnt", 3) == 3))
    {
      sscanf (string," %*s %s %lf %lf %lf", &pnt[anz->p].name,
              &pnt[anz->p].px, &pnt[anz->p].py, &pnt[anz->p].pz);
      pnt[anz->p].nod=-1;
      /* printf ("\n n=%s x=%lf y=%lf z=%lf",  pnt[anz->p].name,
              pnt[anz->p].px, pnt[anz->p].py, pnt[anz->p].pz); */
      anz->p++;
    }
    else if ((compare(&string[1], "LINE", 4) == 4)||(compare(&string[1], "line", 4) == 4))
    {
      sscanf (string," %*s %s %lf %lf %lf", &line[anz->l].name,
              &pnt[anz->p].px, &pnt[anz->p].py, &pnt[anz->p].pz);
      ;
    }
    else if ((compare(&string[1], "LCMB", 4) == 4)||(compare(&string[1], "lcmb", 4) == 4))
    {
      ;
    }
    else if ((compare(&string[1], "GSUR", 4) == 4)||(compare(&string[1], "gsur", 4) == 4))
    {
      ;
    }
    else if ((compare(&string[1], "GBOD", 4) == 4)||(compare(&string[1], "gbod", 4) == 4))
    {
      ;
    }
    else if ((compare(&string[1], "SETA", 4) == 4)||(compare(&string[1], "seta", 4) == 4))
    {
      ;
    }
    else if ((compare(&string[1], "SEQA", 4) == 4)||(compare(&string[1], "seqa", 4) == 4))
    {
      ;
    }
    else
    {
      printf ("\n untranslated record:\n%s\n", &string[0]);
    }
  }

  if (anz->p)
  {
    printf ("\n %i pnts counted and stored.\n\n", anz->p);
    if ( (set[0].pnt = (int *)malloc( (anz->p+1) * sizeof(int))) == NULL )
      printf(" ERROR: malloc Fehler in set[%d]:%s\n\n", 0, set[0].name);
    for(i=0; i<anz->p; i++)
    {
      set[0].pnt[ (set[0].anz_p) ]= i;
      set[0].anz_p++;
    }
  }
  if (anz->l)
  {
    printf ("\n %i lines counted and stored.\n\n", anz->l);
    if ( (set[0].line = (int *)malloc( (anz->l+1) * sizeof(int))) == NULL )
      printf(" ERROR: malloc Fehler in set[%d]:%s\n\n", 0, set[0].name);
    for(i=0; i<anz->l; i++)
    {
      set[0].line[ (set[0].anz_l) ]= i;
      set[0].anz_l++;
    }
  }
  if (anz->c)
  {
    printf ("\n %i lcmb counted and stored.\n\n", anz->c);
    if ( (set[0].lcmb= (int *)malloc( (anz->c+1) * sizeof(int))) == NULL )
      printf(" ERROR: malloc Fehler in set[%d]:%s\n\n", 0, set[0].name);
    for(i=0; i<anz->c; i++)
    {
      set[0].lcmb[ (set[0].anz_c) ]= i;
      set[0].anz_c++;
    }
  }
  if (anz->s)
  {
    printf ("\n %i surf counted and stored.\n\n", anz->s);
    if ( (set[0].surf= (int *)malloc( (anz->s+1) * sizeof(int))) == NULL )
      printf(" ERROR: malloc Fehler in set[%d]:%s\n\n", 0, set[0].name);
    for(i=0; i<anz->s; i++)
    {
      set[0].surf[ (set[0].anz_s) ]= i;
      set[0].anz_s++;
    }
  }
  if (anz->b)
  {
    printf ("\n %i body counted and stored.\n\n", anz->b);
    if ( (set[0].body= (int *)malloc( (anz->b+1) * sizeof(int))) == NULL )
      printf(" ERROR: malloc Fehler in set[%d]:%s\n\n", 0, set[0].name);
    for(i=0; i<anz->b; i++)
    {
      set[0].body[ (set[0].anz_b) ]= i;
      set[0].anz_b++;
    }
  }
  if (anz->se)
  {
    printf ("\n %i sets counted and stored.\n\n", anz->s);
    if ( (set[0].set = (int *)malloc( (anz->se+1) * sizeof(int))) == NULL )
      printf(" ERROR: malloc Fehler in set[%d]:%s\n\n", 0, set[0].name);
    for(i=0; i<anz->se; i++)
    {
      set[0].pnt[ (set[0].anz_se) ]= i;
      set[0].anz_se++;
    }
  }


  fclose (handle1);

  *pntptr=pnt;
  *lineptr=line;
  *lcmbptr=lcmb;
  *surptr=surf;
  *bodptr=body;
  *nursptr=nurs;

  return (1);
}







