#include <extUtil.h>

#define MAXVALUE 2147483647
#define MAX_RECORDS 1000
#define MAX_COMMENTS 20
#define LC_OFFS      0
/*-------------------------------------------------------------------------------*/
/* Count each data type and allocate the memory                                  */
/*-------------------------------------------------------------------------------*/

int readAnsys(unsigned char *datin, Summen *anz, Nodes **nptr, Elements **eptr, Datasets **lptr, double phi, int frequency )
{
  FILE *handle1;
  int i, j, e, ld4, ld5, ld7, ld8, ld100;
  static unsigned char rec_str[MAX_LINE_LENGTH];
  unsigned char buffer[MAX_LINE_LENGTH];
  int  anz_nmax, anz_n, anz_e, lc;
  int  anz_n_org=0;
  int  e_nmax=1, e_nmin=1;
  int  length, model_flag;
  int  ipuf;
  int  cur_etype=0;
  double time;
  double r_mat[3][3], s_mat[3][3], prod_mat[3][3];

  int nod, kcs, el, n[20];
  double xx,yy,zz,xy,yz,zx;

  static Nodes     *node;
  static Elements  *elem;
  static Datasets *lcase;

  static int sum_lc[101];

  /* additional entities */
  Elements  *e_enqire;     /* feld in dem e_enqire[elem[i].nr].xx abgelegt ist, statt elem[i].xx */
  int       elnr, intpnt, nd=0;

  /* erstmal viel speicher allocieren, nicht benoetigter wird spaeter freigegeben  */
  if ( (lcase = (Datasets *)malloc( 1 * sizeof(Datasets))) == NULL )
    printf("\n\n ERROR: malloc failed lcase\n\n") ;
  if ( (node = (Nodes *)malloc( NODES * sizeof(Nodes))) == NULL )
    printf("\n\n ERROR: malloc failed node\n\n") ;
  else
    printf ("\n nodes allocated \n");

  if ( (elem = (Elements *)malloc( ELEMENTS * sizeof(Elements))) == NULL )
    printf("\n\n ERROR: malloc failed elem\n\n") ;
  else
    printf (" elem allocated \n");

  anz->n=-1;
  anz->e=-1;
  anz->l=-1;
  ld4=0;
  ld5=0;
  ld7=0;
  ld8=0;
  ld100=0;
  length = 1;
  model_flag=1;

  /* Open the files and check to see that it was opened correctly */
  handle1 = fopen (datin, "r");
  if ( handle1== NULL )  { printf ("\nThe input file \"%s\" could not be opened.\n\n",
				   datin); return (-1); }
  else  printf ("\n%s opened",datin);


  printf ("\n Lese Ansys Karten  \n");
  for (i=0; i<100; i++)
    {
    length = frecord( handle1, rec_str);
    stos(rec_str, 2, 16, buffer);
    if (( compare( buffer, "INITIAL JOBNAME", 15) == 15 )||( compare( buffer, " INITIAL JOBNAME", 15) == 15 ))
      {
      model_flag=!model_flag;
      stos(rec_str,30,36,anz->model);
      printf (" MODEL NAME:  %s\n", anz->model);
      break;
      }
    }
  if (model_flag)
    {
    printf ("\n\n FATAL ERROR: no proper file-format found.\n\n");
    return (-1);
    }
  


  anz->nmax=-10000000;  anz->nmin=10000000;
  anz->emax=-10000000;  anz->emin=10000000;
  e_nmax=-10000000;  e_nmin=10000000;

  while (length > -1)
  {
    length = frecord( handle1, rec_str);
    /*
    printf ("\n record: %s \n", rec_str);
    */
    if ( rec_str[length] == (unsigned char)EOF ) goto noresults;
    if ( compare( rec_str, "end", 3) == 3 ) goto noresults;

    if (((compare( rec_str, "NODE", 4) == 4) && (compare( &rec_str[14], "KCS", 3) == 3)) ||
        ((compare( rec_str, " NODE", 4) == 4) && (compare( &rec_str[14], " KCS", 3) == 3)) )
    {
      anz->n++;               /* ie the line is a GRID statement    */
      sscanf( rec_str," %*s %d %*s %d %*6c %lf %lf %lf", &nod, &kcs, &xx, &yy, &zz);
      node[anz->n].nr = nod;
      node[node[anz->n].nr].indx = anz->n;
      node[node[anz->n].nr].nx = xx;
      node[node[anz->n].nr].ny = yy;
      node[node[anz->n].nr].nz = zz;;
      if (node[anz->n].nr >  anz->nmax)  anz->nmax=node[anz->n].nr;
      if (node[anz->n].nr <  anz->nmin)  anz->nmin=node[anz->n].nr;
      /*
      printf ("\n n=%d x=%lf y=%lf z=%lf",  node[anz->n].nr,
        node[node[anz->n].nr].nx, node[node[anz->n].nr].ny, node[node[anz->n].nr].nz);
      */
    }



    if( (compare( rec_str, "ELEMENT", 7) == 7) ||
        (compare( rec_str, " ELEMENT", 7) == 7)   )
    {
      /* is a new type defined? */
     if( (compare( rec_str, "ELEMENT TYPE", 12) == 12) ||
        (compare( rec_str, " ELEMENT TYPE", 12) == 12)   )
     {
      if( (compare( &rec_str[21], "SOLID45", 7) == 7)||
          (compare( &rec_str[23], "SOLID45", 7) == 7)||
          (compare( &rec_str[24], "SOLID45", 7) == 7)  )
      {
        cur_etype=45;
        for (i=0;i<5;i++) length = frecord( handle1, rec_str);
        for (j=0;j<MAX_COMMENTS; j++)
        {
        length = frecord( handle1, rec_str);
        if ( (compare( rec_str, "ELEMENT", 7) == 7) ||
             (compare( rec_str, " ELEMENT", 7) == 7) )
	  {
          sscanf( rec_str," %*s %d %d %d %d %d %d %d %d %d", &el, &n[0], &n[1], &n[2], &n[3],
            &n[4], &n[5], &n[6], &n[7]);
          anz->e++;               /* ie the line is a GRID statement         */

          elem[anz->e].nr    = el;
          elem[anz->e].type  = 1;
          elem[anz->e].group = 1;
          elem[anz->e].mat   = 1;
          if (elem[anz->e].nr >  anz->emax)  anz->emax=elem[anz->e].nr;
          if (elem[anz->e].nr <  anz->emin)  anz->emin=elem[anz->e].nr;
	  /*
          printf (" e=%d typ=%d mat=%d \n", elem[anz->e].nr,
            elem[anz->e].type, elem[anz->e].group, elem[anz->e].mat );
	  */
          anz->etype[elem[anz->e].type]++;
          for (i=0; i<8; i++)
            {
            elem[anz->e].nod[i] = n[i];
            if (elem[anz->e].nod[i] >  e_nmax)  e_nmax=elem[anz->e].nod[i];
            if (elem[anz->e].nod[i] <  e_nmin)  e_nmin=elem[anz->e].nod[i];
            }
          goto weiter;
	  }
	}
      }
      else if ( (compare( &rec_str[21], "SOLID95", 7) == 7) ||
                (compare( &rec_str[23], "SOLID95", 7) == 7) ||
                (compare( &rec_str[24], "SOLID95", 7) == 7) )
      {
        cur_etype=95;
        for (i=0;i<13;i++) length = frecord( handle1, rec_str);
        for (j=0;j<MAX_COMMENTS; j++)
        {
        length = frecord( handle1, rec_str);
        if( (compare( rec_str, "ELEMENT", 7) == 7) ||
            (compare( rec_str, " ELEMENT", 7) == 7) )
	  {
          sscanf( rec_str," %*s %d %d %d %d %d %d %d %d %d", &el, &n[0], &n[1], &n[2], &n[3],
            &n[4], &n[5], &n[6], &n[7]);
          length = frecord( handle1, rec_str);
          sscanf( rec_str," %d %d %d %d %d %d %d %d",  &n[8], &n[9], &n[10], &n[11],
            &n[16], &n[17], &n[18], &n[19] );
          length = frecord( handle1, rec_str);
          sscanf( rec_str," %d %d %d %d",  &n[12], &n[13], &n[14], &n[15] );
          anz->e++;               /* ie the line is a GRID statement         */

          elem[anz->e].nr    = el;
          elem[anz->e].type  = 1;  /* stresses werden nur an den randknoten gelistet */
          elem[anz->e].group = 1;  /* deshalb werden die he20 als he8 geschrieben */
          elem[anz->e].mat   = 1;
          if (elem[anz->e].nr >  anz->emax)  anz->emax=elem[anz->e].nr;
          if (elem[anz->e].nr <  anz->emin)  anz->emin=elem[anz->e].nr;
	  /*
          printf (" e=%d typ=%d mat=%d \n", elem[anz->e].nr,
            elem[anz->e].type, elem[anz->e].group, elem[anz->e].mat );
	  */
          anz->etype[elem[anz->e].type]++;
          for (i=0; i<20; i++)
            {
            elem[anz->e].nod[i] = n[i];
            if (elem[anz->e].nod[i] >  e_nmax)  e_nmax=elem[anz->e].nod[i];
            if (elem[anz->e].nod[i] <  e_nmin)  e_nmin=elem[anz->e].nod[i];
            }
          goto weiter;
	  }
	}
      }
      else
      {
        printf (" elem not a known type (%s)\n", &rec_str[21]);
      }
     }
     /* type is already defined */
     else
     {
       if( cur_etype==45)
       {
          sscanf( rec_str," %*s %d %d %d %d %d %d %d %d %d", &el, &n[0], &n[1], &n[2], &n[3],
            &n[4], &n[5], &n[6], &n[7]);
          anz->e++;               /* ie the line is a GRID statement         */

          elem[anz->e].nr    = el;
          elem[anz->e].type  = 1;
          elem[anz->e].group = 1;
          elem[anz->e].mat   = 1;
          if (elem[anz->e].nr >  anz->emax)  anz->emax=elem[anz->e].nr;
          if (elem[anz->e].nr <  anz->emin)  anz->emin=elem[anz->e].nr;
	  /*
          printf (" e=%d typ=%d mat=%d \n", elem[anz->e].nr,
            elem[anz->e].type, elem[anz->e].group, elem[anz->e].mat );
	  */
          anz->etype[elem[anz->e].type]++;
          for (i=0; i<8; i++)
          {
            elem[anz->e].nod[i] = n[i];
            if (elem[anz->e].nod[i] >  e_nmax)  e_nmax=elem[anz->e].nod[i];
            if (elem[anz->e].nod[i] <  e_nmin)  e_nmin=elem[anz->e].nod[i];
          }
          goto weiter;
       }
       else if( cur_etype==95)
       {
          sscanf( rec_str," %*s %d %d %d %d %d %d %d %d %d", &el, &n[0], &n[1], &n[2], &n[3],
            &n[4], &n[5], &n[6], &n[7]);
          length = frecord( handle1, rec_str);
          sscanf( rec_str," %d %d %d %d %d %d %d %d",  &n[8], &n[9], &n[10], &n[11],
            &n[16], &n[17], &n[18], &n[19] );
          length = frecord( handle1, rec_str);
          sscanf( rec_str," %d %d %d %d",  &n[12], &n[13], &n[14], &n[15] );
          if( elem[anz->e].nr != el) anz->e++;

          elem[anz->e].nr    = el;
          elem[anz->e].type  = 1;  /* stresses werden nur an den randknoten gelistet */
          elem[anz->e].group = 1;  /* deshalb werden die he20 als he8 geschrieben */
          elem[anz->e].mat   = 1;
          if (elem[anz->e].nr >  anz->emax)  anz->emax=elem[anz->e].nr;
          if (elem[anz->e].nr <  anz->emin)  anz->emin=elem[anz->e].nr;
	  
          printf (" e=%d typ=%d group=%d mat=%d \n", elem[anz->e].nr,
            elem[anz->e].type, elem[anz->e].group, elem[anz->e].mat );
	  
          anz->etype[elem[anz->e].type]++;
          for (i=0; i<20; i++)
          {
            elem[anz->e].nod[i] = n[i];
            if (elem[anz->e].nod[i] >  e_nmax)  e_nmax=elem[anz->e].nod[i];
            if (elem[anz->e].nod[i] <  e_nmin)  e_nmin=elem[anz->e].nod[i];
          }
          goto weiter;
       }
       else
       {
          printf (" elem not a known type (%d)\n", cur_etype);
       }
     }       
    }       
    weiter:;
      




    if( ( compare(&rec_str[7], "POST", 4) == 4 ) ||
        ( compare(&rec_str[8], "POST", 4) == 4 ) )
    {
      printf ("ERROR: found <POST> statement before <FINISH SOLUTION PROCESSING> statement.\n \
               please insert <FINISH SOLUTION PROCESSING> before the Postprocessor output\n\n");
      exit(-1);
    }
    if( ((compare( rec_str, "FINISH SOLUTION PROCESSING", 10) == 10)&&(anz->n>0)) ||
        ((compare( rec_str, " FINISH SOLUTION PROCESSING", 10) == 10)&&(anz->n>0)) )
    {
      printf ("found: FINISH SOLUTION PROCESSING\n");
      /* for cyc-symmetry solution: */
      /* copy the sector if phi!=0. to display results at theta=0 and theta=90 */
      
      if(phi!=0.)
      {
        printf ("copy segment\n");
        printf("nodes\n");
        anz_nmax=anz->nmax;
        anz_n=anz->n+1;
        anz_e=anz->e+1;
        anz_n_org=anz->n+1;
        for (nod=0; nod<anz_n; nod++)
        {
          anz->n++;
          node[nod+anz_n].nr = node[nod].nr + anz_nmax;
          node[node[nod+anz_n].nr].nx=node[node[nod].nr].nx*cos(phi)+node[node[nod].nr].ny*sin(phi);
          node[node[nod+anz_n].nr].ny=node[node[nod].nr].nx*-sin(phi)+node[node[nod].nr].ny*cos(phi);
          node[node[nod+anz_n].nr].nz = node[node[nod].nr].nz;
          if (node[nod+anz_n].nr >  anz->nmax)  anz->nmax=node[nod+anz_n].nr;
          if (node[nod+anz_n].nr <  anz->nmin)  anz->nmin=node[nod+anz_n].nr;
        }
        printf("elements\n");
        for (e=0; e<anz_e; e++)
        {
          anz->e++;
          elem[anz->e].nr = anz->emax+1;
          elem[anz->e].type = elem[e].type;
          elem[anz->e].group = elem[e].group+1;
          elem[anz->e].mat = elem[e].mat;
          if (elem[anz->e].nr >  anz->emax)  anz->emax=elem[anz->e].nr;
          if (elem[anz->e].nr <  anz->emin)  anz->emin=elem[anz->e].nr;
          ipuf=0;
          if (elem[e].type == 11) ipuf = 2;  /* CBEAM */
          if (elem[e].type == 1) ipuf = 8;  /* CHEXA8 */
          if (elem[e].type == 4) ipuf = 20;  /* CHEXA20 */
          if (elem[e].type == 7) ipuf = 3;  /* CTRI3  */
          if (elem[e].type == 9) ipuf = 4;  /* CQUAD4 */
          if (elem[e].type == 10) ipuf = 8;  /* CQUAD8 */
          if (ipuf==0)
          {
            printf (" elem(%d) not a known type (%d)\n", elem[e].nr, elem[e].type);
          }
          else
          {
            for (nod=0; nod<ipuf; nod++)
            {
              elem[anz->e].nod[nod] = elem[e].nod[nod] + anz_nmax;
              if (elem[anz->e].nod[nod] >  e_nmax)  e_nmax=elem[anz->e].nod[nod];
              if (elem[anz->e].nod[nod] <  e_nmin)  e_nmin=elem[anz->e].nod[nod];
            }
          }
        }
      }
      anz->n++;
      anz->e++;
      if ((elem =(Elements *)realloc((Elements *)elem,(anz->emax+1)*sizeof(Elements)))==NULL )
        printf("\n\n ERROR: realloc failed elem\n\n") ;
      else
        printf ("\n sum-elem:%d, %d elem reallocated \n", anz->e, anz->emax);
      if ( anz->e > anz->emax )
      {
        printf ("ERROR: anz->e > anz->emax, Check for multi-output in out-file\n\a");
        exit(-1);
      }
      if ((node =(Nodes *)realloc((Nodes *)node, (anz->nmax+1) * sizeof(Nodes))) == NULL )
        printf("\n\n ERROR: realloc failed node\n\n") ;
      else
        printf ("\n sum-nodes:%d, %d nodes reallocated \n", anz->n, anz->nmax);
      if ( anz->n > anz->nmax )
      {
        printf ("ERROR: anz->n > anz->nmax, Check for multi-output in out-file\n\a");
        exit(-1);
      }

      break;
    }
  }

  while (length > -1)
  {
    length = frecord( handle1, rec_str);
    /*
    printf ("\n record: %s \n", rec_str);
    */
    if ( rec_str[length] == (unsigned char)EOF ) goto noresults;
    if( ( compare( rec_str, "end", 3) == 3 ) ||
        ( compare( rec_str, " end", 3) == 3 ) ) goto noresults;

    if( (compare( &rec_str[29], "ANSYS RUN COMPLETED", 19) == 19) ||
        (compare( &rec_str[30], "ANSYS RUN COMPLETED", 19) == 19) ) break;


    if(((compare(&rec_str[7], "POST", 4)==4)&&(compare( &rec_str[13],"NODAL DEGREE",12)==12)) ||
       (( compare(&rec_str[8], "POST", 4)==4)&&(compare( &rec_str[14],"NODAL DEGREE",12)==12)) )
    {
      sum_lc[0]++;
      if(sum_lc[0]>frequency) sum_lc[0]=1;
      if(sum_lc[0]>1)  goto no_lc;
      length = frecord( handle1, rec_str);
      length = frecord( handle1, rec_str);
      length = frecord( handle1, rec_str);

      anz_n=0;
      anz->l++;               /* I found a displacement loadcase! */
      if ( (lcase = (Datasets *)realloc((Datasets *)lcase, (anz->l+2) * sizeof(Datasets))) == NULL )
      { printf("\n\n ERROR: malloc failure\n\n" ); exit(1); }
      ld4++;

      sscanf( &rec_str[8], "%lf", &time );
      sprintf( lcase[anz->l].name, "LD%-5d", ld4+LC_OFFS );
      lcase[anz->l].value=time;
      lcase[anz->l].ncomps = 3;
      lcase[anz->l].irtype = 1;
      printf ("lcase.name[%d]=%s time:%lf\n", anz->l, lcase[anz->l].name, lcase[anz->l].value);

      if ( (lcase[anz->l].max = (float *)malloc( lcase[anz->l].ncomps * sizeof(float))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].min = (float *)malloc( lcase[anz->l].ncomps * sizeof(float))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].dat = (float **)malloc( lcase[anz->l].ncomps * sizeof(float *))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].compName = (unsigned char **)malloc( lcase[anz->l].ncomps * sizeof(unsigned char *))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].icname = (unsigned char **)malloc( lcase[anz->l].ncomps * sizeof(unsigned char *))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      for(i=0; i<lcase[anz->l].ncomps; i++)
      {
        if ( (lcase[anz->l].dat[i] = (float *)malloc( (anz->nmax+1) * sizeof(float))) == NULL )
          printf("\n\n ERROR: malloc failure\n\n" );	               
        if ( (lcase[anz->l].compName[i] = (unsigned char *)malloc( MAX_LINE_LENGTH * sizeof(unsigned char))) == NULL )
           printf("\n\n ERROR: malloc failed\n\n" );
        if ( (lcase[anz->l].icname[i] = (unsigned char *)malloc( MAX_LINE_LENGTH * sizeof(unsigned char))) == NULL )
           printf("\n\n ERROR: malloc failed\n\n" );
        lcase[anz->l].max[i]=-MAXVALUE;
        lcase[anz->l].min[i]=MAXVALUE;
      }
      if ( (lcase[anz->l].ictype = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].icind1 = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].icind2 = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].iexist = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );

      for(i=0; i<3; i++)
      {
        lcase[anz->l].ictype[i] = 2;
        lcase[anz->l].icind1[i] = i+1;
        lcase[anz->l].icind2[i] = 0;
        lcase[anz->l].iexist[i] = 0;
      }
      strcpy(lcase[anz->l].compName[0], "x       ");
      strcpy(lcase[anz->l].compName[1], "y       ");
      strcpy(lcase[anz->l].compName[2], "z       ");

      printf ("\n reading Block %s \n", rec_str);

      for (i=0; i<MAX_RECORDS; i++)
      {
        length = frecord( handle1, rec_str);
        if( ((compare(&rec_str[3], "NODE", 4) == 4) && (compare( &rec_str[13], "UX", 2) == 2))||
            ((compare(&rec_str[4], "NODE", 4) == 4) && (compare( &rec_str[14], "UX", 2) == 2)) ) break;
      }
      if (i>=MAX_RECORDS) {printf("Format ERROR"); exit(-1);}

      for (i=0; i<anz->n; i++)
      {
        length = frecord( handle1, rec_str);
        if( (compare( rec_str, "MINIMUM", 4) == 4) ||
            (compare( rec_str, " MINIMUM", 4) == 4) ) break;
        if (length > 0)
        {
          anz_n++;
          sscanf(rec_str,"%d %lf %lf %lf", &ipuf, &xx, &yy, &zz);
          if (ipuf>anz->nmax)
          {
            printf("ERROR: found nodeNr in Dataset higher than in Geometry allocated\n");
            exit(-1);
          }
          if((phi!=0.)&&(anz_n>anz_n_org))
          {
            lcase[anz->l].dat[0][ipuf] = xx*cos(phi)+yy*sin(phi);
            lcase[anz->l].dat[1][ipuf] = xx*-sin(phi)+yy*cos(phi);
            lcase[anz->l].dat[2][ipuf] = zz;
          }
          else
	  {
            lcase[anz->l].dat[0][ipuf]       = xx;
            lcase[anz->l].dat[1][ipuf]       = yy;
            lcase[anz->l].dat[2][ipuf]       = zz;
          }
          for (j=0; j<lcase[anz->l].ncomps; j++)
          {
            if (lcase[anz->l].dat[j][ipuf] >  lcase[anz->l].max[j]) lcase[anz->l].max[j]=lcase[anz->l].dat[j][ipuf];
            if (lcase[anz->l].dat[j][ipuf] <  lcase[anz->l].min[j]) lcase[anz->l].min[j]=lcase[anz->l].dat[j][ipuf];
          }
        }
      }
      printf ("\n %d nodes in Dataset\n",anz_n);
    }

    if( (( compare(&rec_str[7], "POST",4)==4)&&(compare(&rec_str[13],"NODAL STRESS", 12)==12))||
        (( compare(&rec_str[8], "POST",4)==4)&&(compare(&rec_str[14],"NODAL STRESS", 12)==12)) )
    {
      sum_lc[1]++;
      if(sum_lc[1]>frequency) sum_lc[1]=1;
      if(sum_lc[1]>1)  goto no_lc;
      length = frecord( handle1, rec_str);
      length = frecord( handle1, rec_str);
      length = frecord( handle1, rec_str);

      anz_n=0;
      anz->l++;               /* I found a stress loadcase! */
      ld5++;
      if ( (lcase = (Datasets *)realloc((Datasets *)lcase, (anz->l+2) * sizeof(Datasets))) == NULL )
      { printf("\n\n ERROR: malloc failure\n\n" ); exit(1); }
      sscanf( &rec_str[8], "%lf", &time );
      sprintf( lcase[anz->l].name,"LS%-5d", ld5+LC_OFFS );
      lcase[anz->l].value=time;
      lcase[anz->l].ncomps = 6;
      lcase[anz->l].irtype = 1;
      printf ("lcase.name[%d]=%s time:%lf\n", anz->l, lcase[anz->l].name, lcase[anz->l].value);

      if ( (lcase[anz->l].max = (float *)malloc( lcase[anz->l].ncomps * sizeof(float))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].min = (float *)malloc( lcase[anz->l].ncomps * sizeof(float))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].dat = (float **)malloc( lcase[anz->l].ncomps * sizeof(float *))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].compName = (unsigned char **)malloc( lcase[anz->l].ncomps * sizeof(unsigned char *))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].icname = (unsigned char **)malloc( lcase[anz->l].ncomps * sizeof(unsigned char *))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      for(i=0; i<lcase[anz->l].ncomps; i++)
      {
        if ( (lcase[anz->l].dat[i] = (float *)malloc( (anz->nmax+1) * sizeof(float))) == NULL )
          printf("\n\n ERROR: malloc failure\n\n" );	               
        if ( (lcase[anz->l].compName[i] = (unsigned char *)malloc( MAX_LINE_LENGTH * sizeof(unsigned char))) == NULL )
           printf("\n\n ERROR: malloc failed\n\n" );
        if ( (lcase[anz->l].icname[i] = (unsigned char *)malloc( MAX_LINE_LENGTH * sizeof(unsigned char))) == NULL )
           printf("\n\n ERROR: malloc failed\n\n" );
        lcase[anz->l].max[i]=-MAXVALUE;
        lcase[anz->l].min[i]=MAXVALUE;
      }
      if ( (lcase[anz->l].ictype = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].icind1 = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].icind2 = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].iexist = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );

      for(i=0; i<lcase[anz->l].ncomps; i++)
      {
        lcase[anz->l].ictype[i] = 4;
        lcase[anz->l].iexist[i] = 0;
      }
      lcase[anz->l].icind1[0] = 1;
      lcase[anz->l].icind2[0] = 1;
      lcase[anz->l].icind1[1] = 2;
      lcase[anz->l].icind2[1] = 2;
      lcase[anz->l].icind1[2] = 3;
      lcase[anz->l].icind2[2] = 3;
      lcase[anz->l].icind1[3] = 1;
      lcase[anz->l].icind2[3] = 2;
      lcase[anz->l].icind1[4] = 2;
      lcase[anz->l].icind2[4] = 3;
      lcase[anz->l].icind1[5] = 3;
      lcase[anz->l].icind2[5] = 1;

      strcpy(lcase[anz->l].compName[0], "xx      ");
      strcpy(lcase[anz->l].compName[1], "yy      ");
      strcpy(lcase[anz->l].compName[2], "zz      ");
      strcpy(lcase[anz->l].compName[3], "xy      ");
      strcpy(lcase[anz->l].compName[4], "yz      ");
      strcpy(lcase[anz->l].compName[5], "zx      ");

      printf ("\n read Block %s \n", rec_str);

      for (i=0; i<MAX_RECORDS; i++)
      {
        length = frecord( handle1, rec_str);
        if( ((compare(&rec_str[3],"NODE", 4) == 4) && (compare(&rec_str[11], "SX", 2) == 2))||              ((compare(&rec_str[4],"NODE", 4) == 4) && (compare(&rec_str[12], "SX", 2) == 2)) ) break;
      }
      if (i>=MAX_RECORDS) {printf("Format ERROR"); exit(-1);}

      /* for rotation of stress tensors of slave segments if cycsym */
      r_mat[0][0]=1.;
      r_mat[0][1]=0.;
      r_mat[0][2]=0.;
      r_mat[1][0]=0.;
      r_mat[1][1]=cos(phi);
      r_mat[1][2]=sin(phi);
      r_mat[2][0]=0.;
      r_mat[2][1]=-sin(phi);
      r_mat[2][2]=cos(phi);

      for (i=0; i<anz->n; i++)
      {
        length = frecord( handle1, rec_str);
        if( (compare( rec_str, "MINIMUM", 4) == 4) ||
            (compare( rec_str, " MINIMUM", 4) == 4) ) break;
        if (length > 0)
        {
          anz_n++;
          sscanf(rec_str,"%d %lf %lf %lf %lf %lf %lf", &ipuf, &xx, &yy, &zz, &xy, &yz, &zx );
          if (ipuf>anz->nmax)
          {
            printf("ERROR: found nodeNr in Dataset higher than in Geometry allocated\n");
            exit(-1);
          }

          if((phi!=0.)&&(anz_n>anz_n_org)) /* for cycsym */
          {
  	    s_mat[0][0]=   xx;
  	    s_mat[0][1]=   xy;
  	    s_mat[0][2]=   zx;
  	               
  	    s_mat[1][0]=   xy;
  	    s_mat[1][1]=   yy;
  	    s_mat[1][2]=   yz;
  	              
  	    s_mat[2][0]=   zx;
  	    s_mat[2][1]=   yz;
  	    s_mat[2][2]=   zz;
  
            lc=3;
            m_prod( &lc, &r_mat[0][0], &s_mat[0][0], &prod_mat[0][0]);
            m_prodtr( &lc, &prod_mat[0][0], &r_mat[0][0], &s_mat[0][0]);
  
            lcase[anz->l].dat[0][ipuf]  =s_mat[0][0]; /* xx */
            lcase[anz->l].dat[3][ipuf]  =s_mat[0][1]; /* xy */
            lcase[anz->l].dat[i][ipuf]  =s_mat[0][2]; /* zx */
  	                    	                
            lcase[anz->l].dat[3][ipuf]  =s_mat[1][0]; /* xy */
            lcase[anz->l].dat[1][ipuf]  =s_mat[1][1]; /* yy */
            lcase[anz->l].dat[4][ipuf]  =s_mat[1][2]; /* yz */
  	                    	                
            lcase[anz->l].dat[5][ipuf]  =s_mat[2][0]; /* zx */
            lcase[anz->l].dat[4][ipuf]  =s_mat[2][1]; /* yz */
            lcase[anz->l].dat[2][ipuf]  =s_mat[2][2]; /* zz */
          }
          else
          {
            lcase[anz->l].dat[0][ipuf]     = xx;
            lcase[anz->l].dat[1][ipuf]     = yy;
            lcase[anz->l].dat[2][ipuf]     = zz;
            lcase[anz->l].dat[3][ipuf]     = xy;
            lcase[anz->l].dat[4][ipuf]     = yz;
            lcase[anz->l].dat[5][ipuf]     = zx;
          }
          for(j=0; j<lcase[anz->l].ncomps; j++)
	  {
            if (lcase[anz->l].dat[j][ipuf] >  lcase[anz->l].max[j]) lcase[anz->l].max[j]=lcase[anz->l].dat[j][ipuf];
            if (lcase[anz->l].dat[j][ipuf] <  lcase[anz->l].min[j]) lcase[anz->l].min[j]=lcase[anz->l].dat[j][ipuf];
	  }
        }
        else exit(-1);
      }
      printf ("\n %d nodes in Dataset\n",anz_n);
    }


    if( (( compare( &rec_str[7], "POST", 4)==4)&&(compare( &rec_str[13], "NODAL CREEP STRAIN LISTING", 26)==26)) ||
        (( compare( &rec_str[8], "POST", 4)==4)&&(compare( &rec_str[14], "NODAL CREEP STRAIN LISTING", 26)==26)) )
      {
      sum_lc[2]++;
      if(sum_lc[2]>frequency) sum_lc[2]=1;
      if(sum_lc[2]>1)  goto no_lc;
      length = frecord( handle1, rec_str);
      length = frecord( handle1, rec_str);
      length = frecord( handle1, rec_str);

      anz_n=0;
      anz->l++;               /* I found a creep loadcase! */
      ld8++;
      if ( (lcase = (Datasets *)realloc((Datasets *)lcase, (anz->l+2) * sizeof(Datasets))) == NULL )
      { printf("\n\n ERROR: malloc failure\n\n" ); exit(1); }

      sscanf( &rec_str[8], "%lf", &time );
      sprintf( lcase[anz->l].name,"LC%-5d", ld8+LC_OFFS );
      lcase[anz->l].value=time;
      lcase[anz->l].ncomps = 6;
      lcase[anz->l].irtype = 1;
      printf ("lcase.name[%d]=%s time:%lf\n", anz->l, lcase[anz->l].name, lcase[anz->l].value);

      if ( (lcase[anz->l].max = (float *)malloc( lcase[anz->l].ncomps * sizeof(float))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].min = (float *)malloc( lcase[anz->l].ncomps * sizeof(float))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].dat = (float **)malloc( lcase[anz->l].ncomps * sizeof(float *))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].compName = (unsigned char **)malloc( lcase[anz->l].ncomps * sizeof(unsigned char *))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].icname = (unsigned char **)malloc( lcase[anz->l].ncomps * sizeof(unsigned char *))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      for(i=0; i<lcase[anz->l].ncomps; i++)
      {
        if ( (lcase[anz->l].dat[i] = (float *)malloc( (anz->nmax+1) * sizeof(float))) == NULL )
          printf("\n\n ERROR: malloc failure\n\n" );	               
        if ( (lcase[anz->l].compName[i] = (unsigned char *)malloc( MAX_LINE_LENGTH * sizeof(unsigned char))) == NULL )
           printf("\n\n ERROR: malloc failed\n\n" );
        if ( (lcase[anz->l].icname[i] = (unsigned char *)malloc( MAX_LINE_LENGTH * sizeof(unsigned char))) == NULL )
           printf("\n\n ERROR: malloc failed\n\n" );
        lcase[anz->l].max[i]=-MAXVALUE;
        lcase[anz->l].min[i]=MAXVALUE;
      }
      if ( (lcase[anz->l].ictype = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].icind1 = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].icind2 = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].iexist = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );

      for(i=0; i<lcase[anz->l].ncomps; i++)
      {
        lcase[anz->l].ictype[i] = 4;
        lcase[anz->l].iexist[i] = 0;
      }
      lcase[anz->l].icind1[0] = 1;
      lcase[anz->l].icind2[0] = 1;
      lcase[anz->l].icind1[1] = 2;
      lcase[anz->l].icind2[1] = 2;
      lcase[anz->l].icind1[2] = 3;
      lcase[anz->l].icind2[2] = 3;
      lcase[anz->l].icind1[3] = 1;
      lcase[anz->l].icind2[3] = 2;
      lcase[anz->l].icind1[4] = 2;
      lcase[anz->l].icind2[4] = 3;
      lcase[anz->l].icind1[5] = 3;
      lcase[anz->l].icind2[5] = 1;

      strcpy ( lcase[anz->l].compName[0], "EPCR1   ");
      strcpy ( lcase[anz->l].compName[1], "EPCR2   ");
      strcpy ( lcase[anz->l].compName[2], "EPCR3   ");
      strcpy ( lcase[anz->l].compName[3], "EPCRINT ");
      strcpy ( lcase[anz->l].compName[4], "EPCREQV ");

      printf ("\n read Block %s \n", rec_str);

      for (i=0; i<MAX_RECORDS; i++)
      {
        length = frecord( handle1, rec_str);
        if( ((compare( &rec_str[3], "NODE", 4)==4) && (compare( &rec_str[11], "EPCR1", 5)==5))||
            ((compare( &rec_str[4], "NODE", 4)==4) && (compare( &rec_str[12], "EPCR1", 5)==5)) ) break;
      }
      if (i>=MAX_RECORDS) {printf("Format ERROR"); exit(-1);}

      for (i=0; i<anz->n; i++)
      {
        length = frecord( handle1, rec_str);
        if( (compare( rec_str, "MINIMUM", 4) == 4) ||
            (compare( rec_str, " MINIMUM", 4) == 4) ) break;
        if (length > 0)
        {
          anz_n++;
          sscanf(rec_str,"%d %lf %lf %lf %lf %lf ", &ipuf, &xx, &yy, &zz, &xy, &yz );
          if (ipuf>anz->nmax)
          {
            printf("ERROR: found nodeNr in Dataset higher than in Geometry allocated\n");
            exit(-1);
          }
          lcase[anz->l].dat[0][ipuf]     = xx;
          lcase[anz->l].dat[1][ipuf]     = yy;
          lcase[anz->l].dat[2][ipuf]     = zz;
          lcase[anz->l].dat[3][ipuf]     = xy;
          lcase[anz->l].dat[4][ipuf]     = yz;
          lcase[anz->l].dat[5][ipuf]     = 0.;
          for (j=0; j<lcase[anz->l].ncomps; j++)
          {
            if(lcase[anz->l].dat[j][ipuf] > lcase[anz->l].max[j]) lcase[anz->l].max[j]=lcase[anz->l].dat[j][ipuf];
            if(lcase[anz->l].dat[j][ipuf] < lcase[anz->l].min[j]) lcase[anz->l].min[j]=lcase[anz->l].dat[j][ipuf];
          }
        }
        else
          exit(-1);
      }
      printf ("\n %d nodes in Dataset\n",anz_n);
    }


    if( (( compare( &rec_str[7], "POST", 4)==4)&&(compare( &rec_str[29], "TEMPER", 6)==6)) ||
        (( compare( &rec_str[8], "POST", 4)==4)&&(compare( &rec_str[30], "TEMPER", 6)==6)) )
    {
      sum_lc[3]++;
      if(sum_lc[3]>frequency) sum_lc[3]=1;
      if(sum_lc[3]>1)  goto no_lc;
      length = frecord( handle1, rec_str);
      length = frecord( handle1, rec_str);
      length = frecord( handle1, rec_str);

      anz_n=0;
      anz->l++;               /* I found a Temp loadcase! */
      ld7++;
      if ( (lcase = (Datasets *)realloc((Datasets *)lcase, (anz->l+2) * sizeof(Datasets))) == NULL )
      { printf("\n\n ERROR: malloc failure\n\n" ); exit(1); }

      sscanf( &rec_str[8], "%lf", &time );
      sprintf( lcase[anz->l].name,"LT%-5d", ld7+LC_OFFS );
      lcase[anz->l].value=time;
      lcase[anz->l].ncomps = 1;
      lcase[anz->l].irtype = 1;
      printf ("lcase.name[%d]=%s time:%lf\n", anz->l, lcase[anz->l].name, lcase[anz->l].value);

      if ( (lcase[anz->l].max = (float *)malloc( lcase[anz->l].ncomps * sizeof(float))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].min = (float *)malloc( lcase[anz->l].ncomps * sizeof(float))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].dat = (float **)malloc( lcase[anz->l].ncomps * sizeof(float *))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].compName = (unsigned char **)malloc( lcase[anz->l].ncomps * sizeof(unsigned char *))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].icname = (unsigned char **)malloc( lcase[anz->l].ncomps * sizeof(unsigned char *))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      for(i=0; i<lcase[anz->l].ncomps; i++)
      {
        if ( (lcase[anz->l].dat[i] = (float *)malloc( (anz->nmax+1) * sizeof(float))) == NULL )
          printf("\n\n ERROR: malloc failure\n\n" );	               
        if ( (lcase[anz->l].compName[i] = (unsigned char *)malloc( MAX_LINE_LENGTH * sizeof(unsigned char))) == NULL )
           printf("\n\n ERROR: malloc failed\n\n" );
        if ( (lcase[anz->l].icname[i] = (unsigned char *)malloc( MAX_LINE_LENGTH * sizeof(unsigned char))) == NULL )
           printf("\n\n ERROR: malloc failed\n\n" );
        lcase[anz->l].max[i]=-MAXVALUE;
        lcase[anz->l].min[i]=MAXVALUE;
      }
      if ( (lcase[anz->l].ictype = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].icind1 = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].icind2 = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].iexist = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );

      for(i=0; i<lcase[anz->l].ncomps; i++)
      {
        lcase[anz->l].ictype[i] = 1;
        lcase[anz->l].icind1[i] = i+1;
        lcase[anz->l].icind2[i] = 0;
        lcase[anz->l].iexist[i] = 0;
      }

      strcpy(lcase[anz->l].compName[0], "Value   ");

      printf ("\n read Block %s \n", rec_str);

      for (i=0; i<MAX_RECORDS; i++)
	{
        length = frecord( handle1, rec_str);
        if( ((compare( &rec_str[3], "NODE", 4)==4) && (compare( &rec_str[11], "BFETEMP", 6)==6))||
            ((compare( &rec_str[4], "NODE", 4)==4) && (compare( &rec_str[12], "BFETEMP", 6)==6)) ) break;
	}
      if (i>=MAX_RECORDS) {printf("Format ERROR"); exit(-1);}

      for (i=0; i<anz->n; i++)
        {
        length = frecord( handle1, rec_str);
        if( (compare( rec_str, "MINIMUM", 4) == 4) ||
            (compare( rec_str, " MINIMUM", 4) == 4) ) break;
        if (length > 0)
          {
          anz_n++;
          sscanf(rec_str,"%d %lf", &ipuf, &xx );
          if (ipuf>anz->nmax)
            {
            printf("ERROR: found nodeNr in Dataset higher than in Geometry allocated\n");
            exit(-1);
            }
          lcase[anz->l].dat[0][ipuf]       = xx;

          if (lcase[anz->l].dat[0][ipuf] >  lcase[anz->l].max[0]) lcase[anz->l].max[0]=lcase[anz->l].dat[0][ipuf];
          if (lcase[anz->l].dat[0][ipuf] <  lcase[anz->l].min[0]) lcase[anz->l].min[0]=lcase[anz->l].dat[0][ipuf];
          }
        }
        printf ("\n %d nodes in Dataset\n",anz_n);
      }



    if( ( compare( &rec_str[4], "TIME =", 6)==6) ||
        ( compare( &rec_str[5], "TIME =", 6)==6) )
    {
      sscanf(&rec_str[11],"%lf ", &time );
    }

    if( ( compare( rec_str, "elem", 4)==4) ||
        ( compare( rec_str, " elem", 4)==4) )
    {
      sum_lc[4]++;
      if(sum_lc[4]>frequency) sum_lc[4]=1;
      if(sum_lc[4]>1)  goto no_lc;
      anz_n=0;
      anz->l++;               /* I found a mixed loadcase! */
      ld100++;
      if ( (lcase = (Datasets *)realloc((Datasets *)lcase, (anz->l+2) * sizeof(Datasets))) == NULL )
      { printf("\n\n ERROR: malloc failure\n\n" ); exit(1); }

      sscanf( &rec_str[8], "%lf", &time );
      sprintf( lcase[anz->l].name,"LC%-5d", ld100+LC_OFFS );
      lcase[anz->l].value=time;
      lcase[anz->l].ncomps = 7; /* one comp for the sum of nodes per element */
      lcase[anz->l].irtype = 1;
      printf ("lcase.name[%d]=%s time:%lf\n", anz->l, lcase[anz->l].name, lcase[anz->l].value);

      if ( (lcase[anz->l].max = (float *)malloc( lcase[anz->l].ncomps * sizeof(float))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].min = (float *)malloc( lcase[anz->l].ncomps * sizeof(float))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].dat = (float **)malloc( lcase[anz->l].ncomps * sizeof(float *))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].compName = (unsigned char **)malloc( lcase[anz->l].ncomps * sizeof(unsigned char *))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].icname = (unsigned char **)malloc( lcase[anz->l].ncomps * sizeof(unsigned char *))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      for(i=0; i<lcase[anz->l].ncomps; i++)
      {
        if ( (lcase[anz->l].dat[i] = (float *)malloc( (anz->nmax+1) * sizeof(float))) == NULL )
          printf("\n\n ERROR: malloc failure\n\n" );	               
        if ( (lcase[anz->l].compName[i] = (unsigned char *)malloc( MAX_LINE_LENGTH * sizeof(unsigned char))) == NULL )
           printf("\n\n ERROR: malloc failed\n\n" );
        if ( (lcase[anz->l].icname[i] = (unsigned char *)malloc( MAX_LINE_LENGTH * sizeof(unsigned char))) == NULL )
           printf("\n\n ERROR: malloc failed\n\n" );
        lcase[anz->l].max[i]=-MAXVALUE;
        lcase[anz->l].min[i]=MAXVALUE;
      }
      if ( (lcase[anz->l].ictype = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].icind1 = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].icind2 = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );
      if ( (lcase[anz->l].iexist = (int *)malloc( lcase[anz->l].ncomps * sizeof(int))) == NULL )
        printf("\n\n ERROR: malloc failure\n\n" );

      for(i=0; i<lcase[anz->l].ncomps; i++)
      {
        lcase[anz->l].ictype[i] = 1;
        lcase[anz->l].iexist[i] = 0;
        lcase[anz->l].icind1[i] = 0;
        lcase[anz->l].icind2[i] = 0;
      }

      /* define component-names */
      /* achtung: in usercr.f fuer tm-law ist die Ueberschriftenzeile fehlerhaft. */
      /* (zwischen "intpt,timval" fehlt ein blank) deshalb werden nur 8 strings erkannt */
      /*      sscanf(rec_str,"%*s %*s %*s %s %s %s %s %s %s", */
      sscanf(rec_str,"%*s %*s %s %s %s %s %s %s",
        lcase[anz->l].compName[0], lcase[anz->l].compName[1], lcase[anz->l].compName[2],
        lcase[anz->l].compName[3], lcase[anz->l].compName[4], lcase[anz->l].compName[5]  );

      printf ("\n reading uservalues: %s %s %s %s %s %s \n",
        lcase[anz->l].compName[0], lcase[anz->l].compName[1], lcase[anz->l].compName[2],
        lcase[anz->l].compName[3], lcase[anz->l].compName[4], lcase[anz->l].compName[5]  );

      length = frecord( handle1, rec_str);

      /* e_enquire anlegen um ueber die elNr und die integrationspnktNr die NodeNr zu bekommen */
      /* ini e_enqire-feld in dem e_enqire[elem[i].nr].xx abgelegt ist, statt elem[i].xx  */
      if ( (e_enqire = (Elements *)malloc( (anz->emax+1) * sizeof(Elements))) == NULL )
        printf("\n\n ERROR: malloc Fehler in main() e_enqire\n\n") ;

      for (i=0; i<anz->e; i++)
      {
        e_enqire[i].nr = elem[i].nr;
        e_enqire[ elem[i].nr ].type    = elem[i].type;
        e_enqire[ elem[i].nr ].group   = elem[i].group;
        e_enqire[ elem[i].nr ].mat     = elem[i].mat;
        if (elem[i].type==7) for (j=0; j<3; j++)
        {
          e_enqire[ elem[i].nr ].nod[j]=elem[i].nod[j];
        }
        else if (elem[i].type==9) for (j=0; j<4; j++)
        {
          e_enqire[ elem[i].nr ].nod[j]=elem[i].nod[j];
        }
        else if (elem[i].type==1) for (j=0; j<8; j++)
        {
          e_enqire[ elem[i].nr ].nod[j]=elem[i].nod[j];
        }
        else if (elem[i].type==4) for (j=0; j<20; j++)
        {
          e_enqire[ elem[i].nr ].nod[j]=elem[i].nod[j];
        }
        else
        {
            printf("Warning in readAnsys: elem.typ not known:%d \n\a", e_enqire[i].type);
        }
      }

      for (i=0; i<anz->n; i++)
      {
        for (j=0; j<lcase[anz->l].ncomps; j++)
        {
          lcase[anz->l].dat[j][i]     = 0.;
          lcase[anz->l].dat[j][i]     = 0.;
        }
      }
      for (i=0; i<anz->e*8; i++)
      {
        if (length > 0)
        {
          anz_n++;
          sscanf(rec_str,"%d %d %lf %lf %lf %lf %lf %lf", &elnr, &intpnt, &xx, &yy, &zz, &xy, &yz, &zx );
          if (elnr>anz->emax)
          {
            printf("ERROR: found elemNr in Dataset higher than in Geometry allocated\n");
            exit(-1);
          }
          nd=e_enqire[ elnr ].nod[intpnt-1];
          lcase[anz->l].dat[0][nd]+= xx;
          lcase[anz->l].dat[1][nd]+= yy;
          lcase[anz->l].dat[2][nd]+= zz;
          lcase[anz->l].dat[3][nd]+= xy;
          lcase[anz->l].dat[4][nd]+= yz;
          lcase[anz->l].dat[5][nd]+= zx;
          lcase[anz->l].dat[6][nd]++;
        }
        else
        {
          printf("ERROR: not enough result records: %d for %d integration points\n\a", i,anz->e*8);
          return(-1);
        }
        length = frecord( handle1, rec_str);
      }

      printf ("compute average stresses and max, min on grid-points\n");

      lcase[anz->l].ncomps = 6; /* redefinition */
      for (i=0; i<anz->n; i++)
      {
        nd=node[i].nr;
        for(j=0; j<lcase[anz->l].ncomps; j++)
	{
          lcase[anz->l].dat[j][nd] = lcase[anz->l].dat[j][nd]/lcase[anz->l].dat[lcase[anz->l].ncomps+1][nd];
        }
      }
      for (i=0; i<anz->n; i++)
      {
        for(j=0; j<lcase[anz->l].ncomps; j++)
	{
          if (lcase[anz->l].dat[j][nd] >  lcase[anz->l].max[j]) lcase[anz->l].max[j]=lcase[anz->l].dat[j][nd];
          if (lcase[anz->l].dat[j][nd] <  lcase[anz->l].min[j]) lcase[anz->l].min[j]=lcase[anz->l].dat[j][nd];
        }
      }
      printf ("\n %d nodes in Dataset\n",anz_n);
    }

    no_lc:;
  }
  noresults:;
  anz->l++;


  fclose (handle1);

  if ( e_nmax > (anz->nmax) )
  {
    printf ("\n WARNING: element requestes a nodename higher than allocated\n\n");
    printf (" e_nmax=%d e_nmin=%d \n", e_nmax, e_nmin );
  }
  if ( e_nmin < 1 )
  {
    printf ("\n WARNING: element requestes a nodename lower than allocated\n\n");
    printf (" e_nmax=%d e_nmin=%d \n", e_nmax, e_nmin );
  }
  elemChecker( anz, node, elem);

   *nptr =  node; *eptr = elem; *lptr = lcase;
  return (1);
}





