/* ----------------------------------------------------------------  */
/* readDyna liest das dyna3D file in eine struktur  22.04.1999 Wittig   */
/* ----------------------------------------------------------------  */

#include <extUtil.h>





/*-------------------------------------------------------------------------------*/
/* Count each data type and allocate the memory                                  */
/*-------------------------------------------------------------------------------*/

int readDyna( unsigned char *datin, Summen *anz, Nodes **nptr, Elements **eptr, Datasets **lptr )
{
  FILE *handle1;
  register i, j, ld4, ld5, ld7;
  static unsigned char rec_str[MAX_LINE_LENGTH], buf1[MAX_LINE_LENGTH], buf2[MAX_LINE_LENGTH];
  int  anz_n, anz_e;
  int  e_nmax, e_nmin;
  int  length, flag, elem_flag, node_flag, model_flag;
  int  ipuf;
  double loadstep;
  double a,b,c;
  int   nokey=0;

  static Nodes     *node;
  static Elements  *elem;


  /* erstmal viel speicher allocieren, nicht benoetigter wird spaeter freigegeben  */
  if ( (node = (Nodes *)malloc( NODES * sizeof(Nodes))) == NULL )
    printf("\n\n ERROR: malloc Fehler node=%d\n\n",node) ;
  else
    printf ("\n %d nodes allocated \n",anz->nmax);

  if ( (elem = (Elements *)malloc( ELEMENTS * sizeof(Elements))) == NULL )
    printf("\n\n ERROR: malloc Fehler elem=%d\n\n",elem) ;
  else
    printf ("\n elem allocated \n");

  anz->n=-1;
  anz->e=-1;
  anz->l=-1;
  ld4=0;
  ld5=0;
  ld7=0;
  length = 1;
  node_flag=1;
  elem_flag=1;
  model_flag=1;

  /* Open the files and check to see that it was opened correctly */
  handle1 = fopen (datin, "r");
  if ((int)handle1==-1)  printf ("\nThe input file \"%s\" could not be opened.\n\n",
     datin);
  else  printf ("\n%s geoeffnet",datin);


    printf ("\n Lese Undef Karten  \n");

    while (length > -1)
      {
        length = frecord( handle1, rec_str);
        printf ("\n record: %s \n", rec_str);
next:;

        if (compare(rec_str, "*NODE", 5 ) == 5 )
          {
          nokey=0;
          printf ("\n lese Block %s \n", rec_str);
          anz->nmax=-10000000.;  anz->nmin=10000000.;
          do
            {
            length = frecord( handle1, rec_str);
            if (compare(rec_str, "*", 1 ) == 1 ) goto next;
            if (length != 0)
              {
              anz->n++;               /* ie the line is a GRID statement    */
               
               length=sscanf ( rec_str, "%d %lf %lf %lf \n", &node[anz->n].nr, &a,&b,&c);
               node[node[anz->n].nr].indx=anz->n;
               node[node[anz->n].nr].nx=a;
               node[node[anz->n].nr].ny=b;
               node[node[anz->n].nr].nz=c;

                if (node[anz->n].nr >  anz->nmax)  anz->nmax=node[anz->n].nr;
                if (node[anz->n].nr <  anz->nmin)  anz->nmin=node[anz->n].nr;
		/*
                printf (" length:%d  n=%d x=%lf y=%lf z=%lf \n",  length, node[anz->n].nr,
                  node[node[anz->n].nr].nx, node[node[anz->n].nr].ny,
                  node[node[anz->n].nr].nz); 
		*/
              }
            }while(length == 4 );
          }


        else if (compare(rec_str, "*ELEMENT", 7 == 7))
          {
          nokey=0;
          printf ("\n lese Block %s \n", rec_str);
          e_nmax=-10000000.;  e_nmin=10000000.;
     	  do
            {
            length = frecord( handle1, rec_str);
            if (compare(rec_str, "*", 1 ) == 1 ) goto next;
            if (length != 0)
              {
              anz->e++;               /* ie the line is a GRID statement         */

              length=sscanf ( rec_str, "%d %d %d %d %d %d %d %d %d %d \n",
                &elem[anz->e].nr, &elem[anz->e].mat,
                &elem[anz->e].nod[0],&elem[anz->e].nod[1],&elem[anz->e].nod[2],&elem[anz->e].nod[3],
                &elem[anz->e].nod[4],&elem[anz->e].nod[5],&elem[anz->e].nod[6],&elem[anz->e].nod[7]);
              elem[anz->e].group = 1;

              ipuf=0;
              if ( length == 4 ){ elem[anz->e].type= 11; ipuf=2; } /* beam2 */
              if ( length == 5 ){ elem[anz->e].type= 7; ipuf=3; } /* CTRIA3 */
              if ( length == 6 ){ elem[anz->e].type= 9; ipuf=4; } /* CQUAD4 */
              if ( length == 8 ){ elem[anz->e].type= 2; ipuf=6; } /* PE6 */
              if ( length == 10 ){ elem[anz->e].type= 1; ipuf=8; } /* HE8 */
	      /*
              printf (" e=%d typ=%d mat=%d \n", elem[anz->e].nr,
                          elem[anz->e].type, elem[anz->e].group, elem[anz->e].mat ); 
	      */
              if (ipuf==0)
                {
                printf (" elem(%d) not a known type (%d)\n", elem[anz->e].nr, elem[anz->e].type);
                }
              else
                {
                anz->etype[elem[anz->e].type]++;
                for (i=0; i<ipuf; i++)
                  {
                  if (elem[anz->e].nod[i] >  e_nmax)  e_nmax=elem[anz->e].nod[i];
                  if (elem[anz->e].nod[i] <  e_nmin)  e_nmin=elem[anz->e].nod[i];
                  }
                }
              }
            }while(length>3);
          }
          else
          {
            nokey++;
            if (nokey>MAX_NOKEY) { printf("MAX_NOKEY:%d reached\a\n\n", nokey); break; }
            printf(" key:%s not known\n", rec_str);
          }
          if( rec_str[length]== (unsigned char)EOF) { printf("\nEOF\n"); break; }

      }
  anz->n++; 
  anz->e++; 
  anz->l++;
  fclose (handle1);

            if ( (node = (Nodes *)realloc( (Nodes *)node, (anz->nmax+1) * sizeof(Nodes))) == NULL )
              printf("\n\n ERROR: realloc Fehler node=%d\n\n",node) ;
            else
            printf ("\n %d nodes reallocated \n",anz->nmax);
            if ( (elem = (Elements *)realloc((Elements *)elem, (anz->e+1) * sizeof(Elements))) == NULL )
              printf("\n\n ERROR: realloc Fehler elem=%d\n\n",elem) ;
            else
              printf ("\n %d elem reallocated \n", anz->e);

  if ( e_nmax > (anz->nmax) )
    {
    printf ("\n ERROR: element requestes a nodename higher than allocated\n\n");
    printf (" e_nmax=%d e_nmin=%d \n", e_nmax, e_nmin );
    exit(-1);
    }
  if ( e_nmin < 1 )
    {
    printf ("\n ERROR: element requestes a nodename lower than allocated\n\n");
    printf (" e_nmax=%d e_nmin=%d \n", e_nmax, e_nmin );
    exit(-1);
    }
  elemChecker( anz, node, elem);

   *nptr =  node; *eptr = elem; 
  return (1);
}

