/* ----------------------------------------------------------------  */
/* readGiff liest das Gifffile in eine struktur  02.08.1997 Wittig   */
/* ----------------------------------------------------------------  */

#include <extUtil.h>





/*-------------------------------------------------------------------------------*/
/* Count each data type and allocate the memory                                  */
/*-------------------------------------------------------------------------------*/

int readGiff( unsigned char *datin, Summen *anz, Nodes **nptr, Elements **eptr, Datasets **lptr )
{
  FILE *handle1;
  int i, ld7;
  static unsigned char rec_str[MAX_LINE_LENGTH];
  int  anz_n;
  int  e_nmax, e_nmin;
  int  length, flag, elem_flag, node_flag, model_flag;
  int  ipuf;
  double loadstep;

  static Nodes     *node;
  static Elements  *elem;
  static Datasets  *lcase=NULL;


  /* erstmal viel speicher allocieren, nicht benoetigter wird spaeter freigegeben  */
  if ( (node = (Nodes *)malloc( NODES * sizeof(Nodes))) == NULL )
    printf("\n\n ERROR: mallo node\n\n") ;
  else
    printf ("\n %d nodes allocated \n",anz->nmax);

  if ( (elem = (Elements *)malloc( ELEMENTS * sizeof(Elements))) == NULL )
    printf("\n\n ERROR: malloc elem\n\n") ;
  else
    printf ("\n elem allocated \n");

  anz->n=-1;
  anz->e=-1;
  anz->l=-1;
  ld7=0;
  length = 1;
  node_flag=1;
  elem_flag=1;
  model_flag=1;

  /* Open the files and check to see that it was opened correctly */
  handle1 = fopen (datin, "r");
  if (handle1==NULL)  printf ("\nThe input file \"%s\" could not be opened.\n\n",
     datin);
  else  printf ("\n%s geoeffnet",datin);


    printf ("\n Lese giff Karten  \n");
    length = frecord( handle1, rec_str);
    flag = stoi(rec_str,1,5);
    if (flag == 1 )
      {
      model_flag=!model_flag;
      stos(rec_str,7,12,anz->model);
      printf (" MODEL NAME:  %s", anz->model);
      }
    else
      {
      printf ("\n\n FATAL ERROR: first record not a model header. flag:%d %s \n\n",flag, rec_str );
      getchar();
      exit (-1);
      }

    while (length > -1)
      {
        length = frecord( handle1, rec_str);
        printf ("\n record: %s \n", rec_str);
        flag = stoi(rec_str,1,5);
        printf ("\n flag: %d \n", flag);

        if (flag == 9999) break;
        if (flag == 1)
        {
          if (model_flag != 1)
          {
            printf ("\n\n FATAL ERROR: Second Model-Haeder found. STOP\n\n");
            getchar();
            exit(-1);
          }
        }

        if ( (flag != 2) && (flag != 3) && (flag != 15) )
          {
          if ( flag < 0 )
          {
            printf ("\n ueberlese record %s \n", rec_str);
          }
          else
          {
           printf ("\n ueberlese Block %s  \n", rec_str);
           do
            {
            length = frecord( handle1, rec_str);
            /* printf ("\n record: %d %s \n",length, rec_str);   */
            if (length != 0)
              {
              flag = stoi(rec_str,1,5);
              }
            }while(flag != -3);
           }
          }


        if ((flag == 2) && (node_flag))
          {
          node_flag=!node_flag;
          printf ("\n lese Block %s \n", rec_str);
          anz->nmax=-10000000.;  anz->nmin=10000000.;
          do
            {
            length = frecord( handle1, rec_str);
            if (length != 0)
              {
              flag = stoi(rec_str,1,3);
              anz->n++;               /* ie the line is a GRID statement    */
              if (flag == -3) break;
              if (flag == -1)
                {
                node[anz->n].nr = stoi(rec_str,12,19);
                node[node[anz->n].nr].nx = stof(rec_str,20,32);
                node[node[anz->n].nr].ny = stof(rec_str,33,45);
                node[node[anz->n].nr].nz = stof(rec_str,46,58);
                if (node[anz->n].nr >  anz->nmax)  anz->nmax=node[anz->n].nr;
                if (node[anz->n].nr <  anz->nmin)  anz->nmin=node[anz->n].nr;
              /*  printf ("\n n=%d x=%lf y=%lf z=%lf",  node[anz->n].nr,
                  node[node[anz->n].nr].nx, node[node[anz->n].nr].ny,
                  node[node[anz->n].nr].nz); */
                }
              }
            }while(flag != -3);
            if ( (node = (Nodes *)realloc( (Nodes *)node, (anz->nmax+1) * sizeof(Nodes))) == NULL )
              printf("\n\n ERROR: realloc node\n\n") ;
            else
            printf ("\n %d nodes reallocated \n",anz->nmax);
          }


        if ((flag == 3) && (elem_flag))
          {
          elem_flag=!elem_flag;
          printf ("\n lese Block %s \n", rec_str);
          e_nmax=-10000000.;  e_nmin=10000000.;
     	  do
            {
            length = frecord( handle1, rec_str);
            if (length != 0)
              {
              flag = stoi(rec_str,1,3);
              anz->e++;               /* ie the line is a GRID statement         */

              if (flag == -3) break;

              elem[anz->e].nr    = stoi(rec_str,12,19);
              elem[anz->e].group = 1;
              elem[anz->e].mat   = 1;
              ipuf=0;
              if ( stoi(rec_str, 26, 29) == 4 ){ elem[anz->e].type= 9; ipuf= 4; } /* CQUAD4 */
              /* printf ("\n%i e=%d typ=%d mat=%d \n", flag, elem[anz->e].nr,
                          elem[anz->e].type, elem[anz->e].group, elem[anz->e].mat ); */
              length = frecord( handle1, rec_str);
              if (ipuf==0)
                {
                printf (" elem(%d) not a known type (%d)\n", elem[anz->e].nr, elem[anz->e].type);
                }
              else
                {
                anz->etype[elem[anz->e].type]++;
                for (i=0; i<ipuf; i++)
                  {
                  elem[anz->e].nod[i] = stoi(rec_str,(9+i*8),(16+i*8));
                  if (elem[anz->e].nod[i] >  e_nmax)  e_nmax=elem[anz->e].nod[i];
                  if (elem[anz->e].nod[i] <  e_nmin)  e_nmin=elem[anz->e].nod[i];
                  }
                }
              }
            else
              exit(-1);
            }while(flag != -3);
            if ( (elem = (Elements *)realloc((Elements *)elem, (anz->e+1) * sizeof(Elements))) == NULL )
              printf("\n\n ERROR: realloc  elem\n\n") ;
            else
              printf ("\n %d elem reallocated \n", anz->e);
          }



        if (flag == 15)
          {
          anz_n=0;
          anz->l++;               /* I found a scalar loadcase! */
          ld7++;
          if ( (lcase = (Datasets *)realloc((Datasets *)lcase, (anz->l+2) * sizeof(Datasets))) == NULL )
          { printf("\n\n ERROR: malloc failure\n\n" ); exit(1); }

          stos( rec_str, 7, 12, lcase[anz->l].name);
          loadstep=stof( rec_str, 25, 36 );
          sprintf( &lcase[anz->l].name[6],"%-5d",(ld7));
          printf ("lcase.name[%d]= %s\n", anz->l, lcase[anz->l].name);

          if ( (lcase[anz->l].dat = (float *)malloc( (anz->nmax+1) * sizeof(float))) == NULL )
            printf("\n\n ERROR: malloc  dx\n\n" );
          printf ("\n dat von Dataset %d allocated \n", anz->l );

          anz->lcq[anz->l]=7;
          printf ("\n lese Block %s \n", rec_str);
          lcase[anz->l].dat_max=-10000000.;  lcase[anz->l].dat_min=10000000.;
          do
            {
            length = frecord( handle1, rec_str);
            if (length > 0)
              {
                flag = stoi(rec_str,1,3);
                if (flag == -3) break;
                if (flag == -1)
                  {

                  anz_n++;
                  ipuf= stoi(rec_str,4,11);
                  lcase[anz->l].dat[ipuf]       = stof(rec_str,12,23);

              if (lcase[anz->l].dat[ipuf] >  lcase[anz->l].dat_max) lcase[anz->l].dat_max=lcase[anz->l].dat[ipuf];
              if (lcase[anz->l].dat[ipuf] <  lcase[anz->l].dat_min) lcase[anz->l].dat_min=lcase[anz->l].dat[ipuf];
                  }
              }
            }while(flag != -3);
          printf ("\n %d nodes in Dataset geladen\n",anz_n);
          }



next:;
      }
  anz->l++;
  fclose (handle1);

  if ( e_nmax > (anz->nmax) )
    {
    printf ("\n ERROR: element requestes a nodename higher than allocated\n\n");
    printf (" e_nmax=%d e_nmin=%d \n", e_nmax, e_nmin );
    exit(-1);
    }
  if ( e_nmin < 1 )
    {
    printf ("\n ERROR: element requestes a nodename lower than allocated\n\n");
    printf (" e_nmax=%d e_nmin=%d \n", e_nmax, e_nmin );
    exit(-1);
    }
  elemChecker( anz, node, elem);

   *nptr =  node; *eptr = elem; *lptr = lcase;
  return (1);
}

