
#include <extUtil.h>

/* **************************************************************************  */
/* berechnet den schnittpunkt zweier graden im 2D raum                         */
/* liefert 0 wenn die graden paralel laufen, sonst 1                           */
/* p1  ursprung der 1. graden                                                  */
/* p2  ursprung der 2. graden                                                  */
/* e1s einheitsvektor der 1. graden                                            */
/* e2s einheitsvektor der 2. graden                                            */
/* ps  schnittpunkt (rueckgabewert)                                            */
/* **************************************************************************  */
int v_sgg( double *p1, double *p2, double *e1s, double *e2s, double *ps)
{
  double f2s, f1s;

   if ((e1s[0] == e2s[0])&&(e1s[1] == e2s[1]))
   {
     return(0);
   }

   f2s= ( (p2[0]-p1[0])-(e1s[0]*(p2[1]-p1[1])/e1s[1]) ) /
         ( (e1s[0]*e2s[1]/e1s[1]) - e2s[0] );

   f1s= ( (p2[1]-p1[1])+ (e2s[1] * f2s) ) /
         ( e1s[1] );

   ps[0]=e2s[0]*f2s;
   ps[1]=e2s[1]*f2s;
   
   return(1);
}

