/* ---------------------------------------------------------------------------------------------  */
/* write_fbd schreibt die fbd-Kommandos                20.05.1998 Wittig   */
/* ---------------------------------------------------------------------------------------------  */

#include <extUtil.h>

int write_fbd(unsigned char *setname, SumGeo *anz, Points *pnt, Lines *line, Lcmb *lcmb, Gsur *surf, Gbod *body, Sets *set )
{
  FILE *handle1;
  register int  i, j, k, n;
  unsigned char string[MAX_LINE_LENGTH], datout[MAX_LINE_LENGTH];
  int length;

  length=sword( setname, string);
  string[length]='.';
  string[length+1]='f';
  string[length+2]='b';
  string[length+3]='d';
  string[length+4]=(int)NULL;
  strcpy( datout, string);
  /* Open the files and check to see that it was opened correctly */
  handle1 = fopen (datout, "w+b");
  if (handle1==NULL) { printf ("\nThe output file \"%s\" could not be opened.\n\n",
     datout); return(-1);}
  else  printf ("\n%s geoeffnet\n",datout);

  printf ("\n write fbd  \n");

  if (anz->p)
  {
    if( compare( setname, "all", 3)==3)
      for (i=0; i<anz->p; i++)
      {
        if( compare( pnt[i].name, "deleted", 7)!= 7 )
          fprintf (handle1, " PNT %-5s %10.5f %14.5f %14.5f \n", pnt[i].name, pnt[i].px,pnt[i].py,pnt[i].pz);
      }
    else
    {
      k=getSetNr(setname);
      for (i=0; i<set[k].anz_p; i++)
      {
        j=set[k].pnt[i];
        fprintf (handle1, " PNT %-5s %10.5f %14.5f %14.5f \n", pnt[j].name, pnt[j].px,pnt[j].py,pnt[j].pz);
      }
    }
  }

  if (anz->l)
  {
    if( compare( setname, "all", 3)==3)
      for (i=0; i<anz->l; i++)
      {
        if (line[i].typ=='a') /* its an arc-line */
        {
        if( compare( line[i].name, "deleted", 7)!= 7 )
          fprintf (handle1, " LINE %s %s %s %s %d              \n",
            line[i].name, pnt[line[i].p1].name,
            pnt[line[i].p2].name, pnt[line[i].trk].name, line[i].div );
        }
        else
        {
        if( compare( line[i].name, "deleted", 7)!= 7 )
          fprintf (handle1, " LINE %s %s %s      %d              \n",
            line[i].name, pnt[line[i].p1].name,
            pnt[line[i].p2].name, line[i].div );
        }
      }
    else
    {
      k=getSetNr(setname);
      for (i=0; i<set[k].anz_l; i++)
      {
        j=set[k].line[i];
        if (line[j].typ=='a') /* its an arc-line */
        {
          fprintf (handle1, " LINE %s %s %s %s %d              \n",
            line[j].name, pnt[line[j].p1].name,
            pnt[line[j].p2].name, pnt[line[j].trk].name, line[j].div );
        }
        else
        {
          fprintf (handle1, " LINE %s %s %s      %d             \n",
            line[j].name, pnt[line[j].p1].name,
            pnt[line[j].p2].name, line[j].div );
        }
      }
    }
  }

  if (anz->c)
  {
    if( compare( setname, "all", 3)==3)
      for (i=0; i<anz->c; i++)
      {
        if( compare( lcmb[i].name, "deleted", 7)!= 7 )
        {
          fprintf (handle1, " LCMB %s ", lcmb[i].name );
          for (j=0; j<lcmb[i].nl; j++)
            fprintf (handle1, " %1c %s", lcmb[i].o[j], line[lcmb[i].l[j]].name );
          fprintf (handle1, " \n");
        }
      }
    else
    {
      k=getSetNr(setname);
      for (i=0; i<set[k].anz_c; i++)
      {
          n=set[k].lcmb[i];
          fprintf (handle1, " LCMB %s ", lcmb[n].name );
          for (j=0; j<lcmb[n].nl; j++)
            fprintf (handle1, " %1c %s", lcmb[n].o[j], line[lcmb[n].l[j]].name );
          fprintf (handle1, " \n");
      }
    }
  }

  if (anz->s)
  {
    if( compare( setname, "all", 3)==3)
    {
      for (i=0; i<anz->s; i++)
      {
        if( compare( surf[i].name, "deleted", 7)!= 7 )
        {
          fprintf (handle1, " GSUR %s %c BLEND ", surf[i].name, surf[i].ori );
          for (j=0; j<surf[i].nl; j++)
          {
            if (surf[i].typ[j]=='l')
            {
              fprintf (handle1, " %1c %s", surf[i].o[j], line[surf[i].l[j]].name );
            }
            else
            {
              fprintf (handle1, " %1c %s", surf[i].o[j], lcmb[surf[i].l[j]].name );
            }
          }
          fprintf (handle1, " \n");
        }
      }
    }
    else
    {
      k=getSetNr(setname);
      for (i=0; i<set[k].anz_s; i++)
      {
          n=set[k].surf[i];
          fprintf (handle1, " GSUR %s %1c BLEND ", surf[n].name, surf[n].ori );
          for (j=0; j<surf[n].nl; j++)
          {
            if (surf[n].typ[j]=='l')
            {
              fprintf (handle1, " %1c %s", surf[n].o[j], line[surf[n].l[j]].name );
            }
            else
            {
              fprintf (handle1, " %1c %s", surf[n].o[j], lcmb[surf[n].l[j]].name );
            }
        }
        fprintf (handle1, " \n");
      }
    }
  }

  if (anz->b)
  {
    if( compare( setname, "all", 3)==3)
      for (i=0; i<anz->b; i++)
      {
        if( compare( body[i].name, "deleted", 7)!= 7 )
        {
          fprintf (handle1, " GBOD %s NORM", body[i].name );
          for (j=0; j<body[i].ns; j++)
            fprintf (handle1, " %1c %s", body[i].o[j], surf[body[i].s[j]].name );
          fprintf (handle1, " \n");
        }
      }
    else
    {
      k=getSetNr(setname);
      for (i=0; i<set[k].anz_b; i++)
      {
        n=set[k].body[i];
        fprintf (handle1, " GBOD %s NORM", body[n].name );
        for (j=0; j<body[n].ns; j++)
          fprintf (handle1, " %1c %s", body[n].o[j], surf[body[n].s[j]].name );
        fprintf (handle1, " \n");
      }
    }
  }

  for (i=0; i<anz->sets; i++)
  {
   length = sword( set[i].name, string);
   if( (compare( set[i].name, setname, length) == length) && (length == strlen(setname)) )
   {
    if (set[i].etyp) 
    {
      if(set[i].etyp==1) fprintf (handle1, " ELTY %s HE8 \n", set[i].name);
      if(set[i].etyp==4) fprintf (handle1, " ELTY %s HE20 \n", set[i].name);
      if(set[i].etyp==6) fprintf (handle1, " ELTY %s TE10 \n", set[i].name);
      if(set[i].etyp==7) fprintf (handle1, " ELTY %s TR3 \n", set[i].name);
      if(set[i].etyp==8) fprintf (handle1, " ELTY %s TR6 \n", set[i].name);
      if(set[i].etyp==9) fprintf (handle1, " ELTY %s QU4 \n", set[i].name);
      if(set[i].etyp==10) fprintf (handle1, " ELTY %s QU8 \n", set[i].name);
      if(set[i].etyp==11) fprintf (handle1, " ELTY %s BE2 \n", set[i].name);
      if(set[i].etyp==12) fprintf (handle1, " ELTY %s BE3 \n", set[i].name);
    }
   }
  }
  for (i=1; i<anz->sets; i++)
  {
   if ( ((compare( set[i].name, setname, length) == length)
        && (length == strlen(setname) ))
     || ((compare( setname, "all", 3) == 3) 
        &&(compare( set[i].name, "deleted", 7) != 7)))
   {

/*  FAM vertraegt nur einen wert hinter der spec.  */

/*
    for (j=0; j<set[i].anz_n; j++)
    {
      fprintf (handle1, " SETA %s n %d \n", set[i].name, set[i].node[j]);
    }
    for (j=0; j<set[i].anz_e; j++)
    {
      fprintf (handle1, " SETA %s e %d \n", set[i].name, set[i].elem[j]);
    }
*/
    for (j=0; j<set[i].anz_p; j++)
    {
      fprintf (handle1, " SETA %s p %s \n", set[i].name, pnt[set[i].pnt[j]].name);
    }
    for (j=0; j<set[i].anz_l; j++)
    {
      fprintf (handle1, " SETA %s l %s \n", set[i].name, line[set[i].line[j]].name);
    }
    for (j=0; j<set[i].anz_c; j++)
    {
      fprintf (handle1, " SETA %s c %s \n", set[i].name, lcmb[set[i].lcmb[j]].name);
    }
    for (j=0; j<set[i].anz_s; j++)
    {
      fprintf (handle1, " SETA %s s %s \n", set[i].name, surf[set[i].surf[j]].name);
    }
    for (j=0; j<set[i].anz_b; j++)
    {
      fprintf (handle1, " SETA %s b %s \n", set[i].name, body[set[i].body[j]].name);
    }
   }
  }
  fprintf (handle1, "\n");
  fclose(handle1);
  return (1);
}





