/* ACHTUNG malloc eingefuehrt und noch nicht getestet 2.3.2000 */
#include <extUtil.h>

#define     MAX_COS_ALFA 0.94 /* mindestoeffnungswinkel eines Intpol.dreiecks */
#define     ANZ_NODES   10   /* anzahl Nodes aus denen die geeignetsten */
                             /* zur Interpolation gesucht werden */
/*----------------------------------------------------------------------------------*/
/* bestimmung des y-wertes am punkt (x,z)                                           */
/* der y-wert wird durch interpolation in einem feld aus x,y,z koordinaten bestimmt */
/*                                                                                  */
/* eingabe:                                                                         */
/* p[0], p[2]: Interpolationspunkt                                                  */
/* nn: Anzahl der stuetzstellen                                                     */
/* xn,yn,zn: Koordinaten der Stuetzstellen                                          */
/*                                                                                  */
/* rueckgabe:                                                                       */
/* p[1]: Interpolationspunkt, p[1]==y (resultat) wird eingefuegt.                   */
/* in: Indexe der 3 stuetzstellen der Dreiecks-interpolation                        */
/*                                                                                  */
/* return(0...err) wenn die Interpolation erfolgreich war.                          */
/*----------------------------------------------------------------------------------*/
int xz_intpol( double *p, int *in, int nn, double *xn, double *yn, double *zn )
{
  int err=0;
  int j,n;
  double xp, zp;
  double dx12, dz12, e12, dx13,dz13,e13,s;

  double *rad2=0, *rad2_sort=0;
  int   *nn_sort=0;
  double *xn_sort=0, *yn_sort=0, *zn_sort=0;

  int ppp[6], puf1, puf2, puf3, puf4, puf5, puf6;
  double denom, mu, lamda;

    xp = p[0];
    zp = p[2];

    /* suche die naechsten stuetzpunkte in der zx-ebene */
    /* Der Abstand der Stuetzpunkte wird in Kartesischen Koordinaten (x,z) bestimmt   */
    if ( (rad2 = (double *)realloc((double *)rad2, nn * sizeof(double))) == NULL )
      printf("\n\n ERROR in xy_intpol: malloc failed \n\n") ;
    if ( (rad2_sort = (double *)realloc((double *)rad2_sort, nn * sizeof(double))) == NULL )
      printf("\n\n ERROR in xy_intpol: malloc failed \n\n") ;
    if ( (nn_sort = (int *)realloc((int *)nn_sort, nn * sizeof(int))) == NULL )
      printf("\n\n ERROR in xy_intpol: malloc failed \n\n") ;
    if ( (xn_sort = (double *)realloc((double *)xn_sort, nn * sizeof(double))) == NULL )
      printf("\n\n ERROR in xy_intpol: malloc failed \n\n") ;
    if ( (yn_sort = (double *)realloc((double *)yn_sort, nn * sizeof(double))) == NULL )
      printf("\n\n ERROR in xy_intpol: malloc failed \n\n") ;
    if ( (zn_sort = (double *)realloc((double *)zn_sort, nn * sizeof(double))) == NULL )
      printf("\n\n ERROR in xy_intpol: malloc failed \n\n") ;
    for (j=0; j < nn; j++)
      {
      rad2[j] = (xn[j]-xp)*(xn[j]-xp) + (zn[j]-zp)*(zn[j]-zp);
      }
    bsort (rad2,rad2_sort,nn_sort,nn);

    xn_sort[0] = xp;
    zn_sort[0] = zp;
    /*
    printf (" nod[0] Z:%lf R:%lf  \n",  xn_sort[0], zn_sort[0] );
    */
    for (j=1; j<= ANZ_NODES; j++)
    {
      xn_sort[j] = xn[nn_sort[nn-j]];
      zn_sort[j] = zn[nn_sort[nn-j]];
      /*
      printf (" nod[%d] Z:%lf R:%lf abs:%lf \n", j, xn_sort[j], zn_sort[j], sqrt(rad2[nn_sort[nn-j]]) );
      */
    }
    n =  p3_finder( ANZ_NODES, xn_sort, zn_sort, ppp);
    if ( n == 1 )
    {
      puf4=nn-ppp[0];
      puf5=nn-ppp[1];
      puf6=nn-ppp[2];
      puf1=nn_sort[puf4];
      puf2=nn_sort[puf5];
      puf3=nn_sort[puf6];
    }
    else
    {
      /* p not in a Triangle */
      /* nimm die zwei naechstliegenden nodes und suche den naechstliegenden dritten, */
      /* der mit diesen ein gesundes dreieck bildet */
      err++;
      puf1=nn_sort[nn-1];
      puf2=nn_sort[nn-2];
      for (j=3; j<= ANZ_NODES; j++)
      {
        puf3=nn_sort[nn-j];
        printf (" p not in a Triangle, check nodes \n");

        /* Oeffnungswinkel checken mittels scalarprodukt */
        dx12=xn[puf2]-xn[puf1];       
        dz12=zn[puf2]-zn[puf1];
        e12=sqrt(dx12*dx12+dz12*dz12);
        dx13=xn[puf3]-xn[puf1];       
        dz13=zn[puf3]-zn[puf1];
        e13=sqrt(dx13*dx13+dz13*dz13);
        s= (dx12*dx13+dz12*dz13)/(e12*e13);
  printf("s:%lf\n", s);
        if(abs(s)>MAX_COS_ALFA)
        {
          /* nodes are all in line, point ignored */
          printf ("  bad triangle, check next. \n");
        }
        else
          break;

        /* Check that the three points we have are not all in a straight line */
	/*
        if ((xn[puf2] == xn[puf1]) && (xn[puf2] == xn[puf3]) ||
        (zn[puf3] == ((zn[puf2]-zn[puf1])/(xn[puf2]-xn[puf1])*xn[puf3] + zn[puf1])))
        {
          printf ("  nodes are all in line, check next. \n");
        }
        else
          break;
*/
      }
    }

    /* Check that the three points we have are not all in a straight line */
    if ((xn[puf2] == xn[puf1]) && (xn[puf2] == xn[puf3]) ||
        (zn[puf3] == ((zn[puf2]-zn[puf1])/(xn[puf2]-xn[puf1])*xn[puf3] + zn[puf1])))
    {
      /* nodes are all on a line, point ignored */
      return(-2);
    }

    /* Now we have three valid closest known nodes, determine yp_r   */
    denom = (zn[puf3]-zn[puf1])*(xn[puf2]-xn[puf1]) - (zn[puf2]-zn[puf1])*(xn[puf3]-xn[puf1]);
    mu    = ((zp-zn[puf1])*(xn[puf2]-xn[puf1]) - (zn[puf2]-zn[puf1])*(xp-xn[puf1])) / denom;
    lamda = ((zn[puf3]-zn[puf1])*(xp-xn[puf1]) - (zp-zn[puf1])*(xn[puf3]-xn[puf1])) / denom;

    p[1] = lamda*(yn[puf2]-yn[puf1]) + mu*(yn[puf3]-yn[puf1]) + yn[puf1];
    in[0]=puf1;
    in[1]=puf2;
    in[2]=puf3;

    return(err);

}


